package org.jeecg.modules.stm.wb.atted.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.wb.atted.entity.WbEmpAtted;
import org.jeecg.modules.stm.wb.atted.service.IWbEmpAttedService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 外包人员考勤表
 * @Author: jeecg-boot
 * @Date:   2025-09-16
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/wb/wbEmpAtted")
@Slf4j
public class WbEmpAttedController extends JeecgController<WbEmpAtted, IWbEmpAttedService> {
	@Autowired
	private IWbEmpAttedService wbEmpAttedService;
	
	/**
	 * 分页列表查询
	 *
	 * @param wbEmpAtted
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "外包人员考勤表-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<WbEmpAtted>> queryPageList(WbEmpAtted wbEmpAtted,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbEmpAtted> queryWrapper = QueryGenerator.initQueryWrapper(wbEmpAtted, req.getParameterMap());
		Page<WbEmpAtted> page = new Page<WbEmpAtted>(pageNo, pageSize);
		IPage<WbEmpAtted> pageList = wbEmpAttedService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param wbEmpAtted
	 * @return
	 */
	@AutoLog(value = "外包人员考勤表-添加")
	  
	@RequiresPermissions("wb:wb_emp_atted:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WbEmpAtted wbEmpAtted) {
		wbEmpAttedService.save(wbEmpAtted);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param wbEmpAtted
	 * @return
	 */
	@AutoLog(value = "外包人员考勤表-编辑")
	  
	@RequiresPermissions("wb:wb_emp_atted:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WbEmpAtted wbEmpAtted) {
		wbEmpAttedService.updateById(wbEmpAtted);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "外包人员考勤表-通过id删除")
	  
	@RequiresPermissions("wb:wb_emp_atted:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbEmpAttedService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "外包人员考勤表-批量删除")
	  
	@RequiresPermissions("wb:wb_emp_atted:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbEmpAttedService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "外包人员考勤表-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<WbEmpAtted> queryById(@RequestParam(name="id",required=true) String id) {
		WbEmpAtted wbEmpAtted = wbEmpAttedService.getById(id);
		if(wbEmpAtted==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbEmpAtted);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbEmpAtted
    */
    @RequiresPermissions("wb:wb_emp_atted:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbEmpAtted wbEmpAtted) {
        return super.exportXls(request, wbEmpAtted, WbEmpAtted.class, "外包人员考勤表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("wb:wb_emp_atted:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbEmpAtted.class);
    }

}
